//+------------------------------------------------------------------+
//|                                                       Fib SR.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"

#property indicator_chart_window



extern int myPeriod = PERIOD_W1;

extern double myFactor1 = 0.382;
extern double myFactor2 = 0.618;
extern double myFactor3 = 1.382;
extern double myFactor4 = 1.618;

extern color clrSup1 = Aqua;
extern color clrSup2 = DodgerBlue;
extern color clrSup3 = DeepSkyBlue;
extern color clrSup4 = Blue;

extern color clr50 = Silver;

extern color clrRes1 = Tan;
extern color clrRes2 = Chocolate;
extern color clrRes3 = DarkOrange;
extern color clrRes4 = Brown;

double A, B, C, D, E, F, G, I, J;
double A1, B1, D1, E1, F1, G1, H1, H2, I1, J1;


string FIB_SUP1 ;
string FIB_SUP2 ;
string FIB_SUP3 ;
string FIB_SUP4 ;
string FIB_50 ;
string FIB_RES1 ;
string FIB_RES2 ;
string FIB_RES3 ;
string FIB_RES4 ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
      Recalc();

 FIB_SUP1 = "FIB_SUP_1" + myPeriod ;
 FIB_SUP2 = "FIB_SUP_2" + myPeriod ;
 FIB_SUP3 = "FIB_SUP_3" + myPeriod ;
 FIB_SUP4 = "FIB_SUP_4" + myPeriod ;
 FIB_50   = "FIB_50"    + myPeriod ;
 FIB_RES1 = "FIB_RES_1" + myPeriod ;
 FIB_RES2 = "FIB_RES_2" + myPeriod ;
 FIB_RES3 = "FIB_RES_3" + myPeriod ;
 FIB_RES4 = "FIB_RES_4" + myPeriod ;


      ObjectDelete(FIB_SUP1);
      ObjectDelete(FIB_SUP2);
      ObjectDelete(FIB_SUP3);
      ObjectDelete(FIB_SUP4);
      
      ObjectDelete(FIB_50);
      
      ObjectDelete(FIB_RES1);
      ObjectDelete(FIB_RES2);
      ObjectDelete(FIB_RES3);
      ObjectDelete(FIB_RES4);
      
       
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
      ObjectDelete(FIB_SUP1);
      ObjectDelete(FIB_SUP2);
      ObjectDelete(FIB_SUP3);
      ObjectDelete(FIB_SUP4);
      
      ObjectDelete(FIB_50);
      
      ObjectDelete(FIB_RES1);
      ObjectDelete(FIB_RES2);
      ObjectDelete(FIB_RES3);
      ObjectDelete(FIB_RES4);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   static datetime dt = 0;
   if (dt != iTime(NULL, myPeriod,0))
   {
      Recalc();
      dt = iTime(NULL, myPeriod,0);
   }  
   if (NewBar())
   {
      ObjectDelete(FIB_SUP1);
      ObjectDelete(FIB_SUP2);
      ObjectDelete(FIB_SUP3);
      ObjectDelete(FIB_SUP4);
      
      ObjectDelete(FIB_50);
      
      ObjectDelete(FIB_RES1);
      ObjectDelete(FIB_RES2);
      ObjectDelete(FIB_RES3);
      ObjectDelete(FIB_RES4);
      
      
      ObjectCreate(FIB_SUP4, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), I, Time[0], I1);ObjectSet(FIB_SUP4, OBJPROP_COLOR, clrSup4);     
      ObjectCreate(FIB_SUP3, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), B, Time[0], B1);ObjectSet(FIB_SUP3, OBJPROP_COLOR, clrSup3);    
      ObjectCreate(FIB_SUP2, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), A, Time[0], A1);ObjectSet(FIB_SUP2, OBJPROP_COLOR, clrSup2);
      ObjectCreate(FIB_SUP1, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), G, Time[0], G1);ObjectSet(FIB_SUP1, OBJPROP_COLOR, clrSup1); 
      
      ObjectCreate(FIB_50, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), H2, Time[0], H1);ObjectSet(FIB_50, OBJPROP_COLOR, clr50); 
           
      ObjectCreate(FIB_RES1, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), F, Time[0], F1);ObjectSet(FIB_RES1, OBJPROP_COLOR, clrRes1);           
      ObjectCreate(FIB_RES2, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), E, Time[0], E1);ObjectSet(FIB_RES2, OBJPROP_COLOR, clrRes2);      
      ObjectCreate(FIB_RES3, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), D, Time[0], D1);ObjectSet(FIB_RES3, OBJPROP_COLOR, clrRes3);      
      ObjectCreate(FIB_RES4, OBJ_RECTANGLE, 0, iTime(NULL, myPeriod, 0), J, Time[0], J1);ObjectSet(FIB_RES4, OBJPROP_COLOR, clrRes4);      
  }
   
   return(0);
  }
//+------------------------------------------------------------------+

bool NewBar()
{
   static datetime dt = 0;
   if (dt != Time[0])
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}

void Recalc()
{
      double C = iClose(NULL, myPeriod, 1); // Yesterday close
      double L = iLow(NULL, myPeriod, 1); // Yesterday Low
      double H = iHigh(NULL, myPeriod, 1); // Yesterday High
      
      double R = (H-L);
      
      C = (H+L+C) / 3;
      D = (R/2) + C;
      F = (R/3) + C;
      B = C - (R/2);
      E = R + C;
      A = C - R;
      G = C - (R/3);
      H2 = C;
      I = C - R*2;
      J = C + R*2;
      
      
      G1 = C - ( R * myFactor1 );
      B1 = C - ( R * myFactor2 );
      A1 = C - ( R * myFactor3 );
      I1 = C - ( R * myFactor4 );
      
      H1 = C-( R * 0.010 ); 
       
      
      F1 = C + ( R * myFactor1 );
      D1 = C + ( R * myFactor2 );
      E1 = C + ( R * myFactor3 );
      J1 = C + ( R * myFactor4 );
}

